#!/bin/sh
# @(#) $Id: aclfw.sh,v 1.2 2006/01/25 01:25:47 leres Exp $ (LBL)

case "$1" in
'start')
	;;

'stop')
	exit
        ;;
*)
	echo "Usage: $0 { start | stop }"
	exit 1
	;;
esac

. /etc/rc.conf

if [ -n "${aclfw_enable}" -a "x${aclfw_enable}" != "xNO" ] ; then
	export PATH="/usr/operator/acl2/scripts:${PATH}"

	echo -n " aclfw"

	prog="`basename $0`"
	watcher="${aclfw_watcher:-root}"

	t1="/tmp/${prog}.1.$$"
	t2="/tmp/${prog}.2.$$"

	files=""
	for f in /var/log/syslog /var/log/messages; do
		files="${files} ${f}"
		f2=${f}.0
		if [ -r ${f2} ]; then
			files="${files} ${f2}"
		fi
	done

	awk '$6 == "NETS" && $7 == "status=success" {
		    ip = "?"
		    if (substr($11, 1, 3) == "ip=")
			    ip = substr($11, 4)
		    if ($10 == "cmd=drop")
			    block[ip] = 1
		    else if ($10 == "cmd=restore")
			    block[ip] = 0
	    }

	    END {
		    for (ip in block)
			    if (block[ip])
				    print ip
	    }' ${files} > ${t1} 2>&1

	if [ -s ${t1} ]; then
		acl.sh drop -f ${t1} > ${t2} 2>&1
		((echo "Subject: `hostname` acld ipfw startup"
		echo "To: ${watcher}"
		echo ""
		echo "Re-blocking:"
		sed -e 's/^/    /' ${t1}
		echo ""
		cat ${t2}) |
		sendmail -bm -froot@ee.lbl.gov -t ; \
		    rm ${t1} ${t2} & ) > /dev/null 2>&1
	else
		rm ${t1}
	fi
fi
